#ifndef id2FC7119D67FA4704B5FE8A9FDA148F46
#define id2FC7119D67FA4704B5FE8A9FDA148F46

#include "doorkeeper/primitivetypes.hpp"
#include <cstdint>

namespace dk {
	template <uint32_t D>
	typename Vector<D>::value_type tile_volume ( const Vector<D>& parFrom, const Vector<D>& parTo ) a_pure;

	template <uint32_t D>
	inline
	typename Vector<D>::value_type tile_volume (const Vector<D>& parFrom, const Vector<D>& parTo) {
		typedef typename Vector<D>::value_type scalar_type;

		scalar_type ret_val((1));

		for (uint32_t z = 0; z < D; ++z) {
			const auto dist(parTo[z] - parFrom[z] + 1);
			ret_val *= dist;
		}
		return ret_val;
	}
} //namespace dk

#endif
